gi-pango-1.0.19: Pango bindings

Copyright | Will Thompson Iñaki García Etxebarria and Jonas Platte
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria (garetxe@gmail.com)
Safe Haskell | None
Language | Haskell2010

GI.Pango.Structs.Language

Contents

- Exported types
- Methods
  - fromString
  - getDefault
  - getSampleString
  - includesScript
  - matches
  - toString

Description

The `Language` structure is used to represent a language.

`Language` pointers can be efficiently copied and compared with each other.

Synopsis

- newtype Language = Language (ManagedPtr Language)
- noLanguage :: Maybe Language
- languageFromString :: (HasCallStack, MonadIO m) => Maybe Text -> m (Maybe Language)
- languageGetDefault :: (HasCallStack, MonadIO m) => m Language
- languageGetSampleString :: (HasCallStack, MonadIO m) => Language -> m Text
- languageIncludesScript :: (HasCallStack, MonadIO m) => Language -> Script -> m Bool
- languageMatches :: (HasCallStack, MonadIO m) => Language -> Text -> m Bool
- languageToString :: (HasCallStack, MonadIO m) => Language -> m Text

# Exported types

newtype Language Source #

Memory-managed wrapper type.

Constructors

Language (ManagedPtr Language) |

Instances

BoxedObject Language Source # |
Instance details Defined in GI.Pango.Structs.Language Methods boxedType :: Language -> IO GType Source #

noLanguage :: Maybe Language Source #

A convenience alias for `Nothing` :: `Maybe` `Language`.

# Methods

## fromString

languageFromString Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Maybe Text | `language`: a string representing a language tag, or `Nothing`
-> m (Maybe Language) | Returns: an opaque pointer to a `Language` structure, or `Nothing` if `language` was `Nothing`. The returned pointer will be valid forever after, and should not be freed.

Take a RFC-3066 format language tag as a string and convert it to a `Language` pointer that can be efficiently copied (copy the pointer) and compared with other language tags (compare the pointer.)

This function first canonicalizes the string by converting it to lowercase, mapping '_' to '-', and stripping all characters other than letters and '-'.

Use `languageGetDefault` if you want to get the `Language` for the current locale of the process.

## getDefault

languageGetDefault Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> m Language | Returns: the default language as a `Language`, must not be freed.

Returns the `Language` for the current locale of the process. Note that this can change over the life of an application.

On Unix systems, this is the return value is derived from <literal>setlocale(LC_CTYPE, NULL)</literal>, and the user can affect this through the environment variables LC_ALL, LC_CTYPE or LANG (checked in that order). The locale string typically is in the form lang_COUNTRY, where lang is an ISO-639 language code, and COUNTRY is an ISO-3166 country code. For instance, sv_FI for Swedish as written in Finland or pt_BR for Portuguese as written in Brazil.

On Windows, the C library does not use any such environment variables, and setting them won't affect the behavior of functions like `ctime()`. The user sets the locale through the Regional Options in the Control Panel. The C library (in the `setlocale()` function) does not use country and language codes, but country and language names spelled out in English. However, this function does check the above environment variables, and does return a Unix-style locale string based on either said environment variables or the thread's current locale.

Your application should call <literal>setlocale(LC_ALL, "");</literal> for the user settings to take effect. Gtk+ does this in its initialization functions automatically (by calling `gtk_set_locale()`). See <literal>man setlocale</literal> for more details.

Since: 1.16

## getSampleString

languageGetSampleString Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Language | `language`: a `Language`, or `Nothing`
-> m Text | Returns: the sample string. This value is owned by Pango and should not be freed.

Get a string that is representative of the characters needed to render a particular language.

The sample text may be a pangram, but is not necessarily. It is chosen to be demonstrative of normal text in the language, as well as exposing font feature requirements unique to the language. It is suitable for use as sample text in a font selection dialog.

If `language` is `Nothing`, the default language as found by `languageGetDefault` is used.

If Pango does not have a sample string for `language`, the classic "The quick brown fox..." is returned. This can be detected by comparing the returned pointer value to that returned for (non-existent) language code "xx". That is, compare to: <informalexample><programlisting> pango_language_get_sample_string (pango_language_from_string ("xx")) </programlisting></informalexample>

## includesScript

languageIncludesScript Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Language | `language`: a `Language`, or `Nothing`
-> Script | `script`: a `Script`
-> m Bool | Returns: `True` if `script` is one of the scripts used to write `language` or if nothing is known about `language` (including the case that `language` is `Nothing`), `False` otherwise.

Determines if `script` is one of the scripts used to write `language`. The returned value is conservative; if nothing is known about the language tag `language`, `True` will be returned, since, as far as Pango knows, `script` might be used to write `language`.

This routine is used in Pango's itemization process when determining if a supplied language tag is relevant to a particular section of text. It probably is not useful for applications in most circumstances.

This function uses `languageGetScripts` internally.

Since: 1.4

## matches

languageMatches Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Language | `language`: a language tag (see `languageFromString`), `Nothing` is allowed and matches nothing but '*'
-> Text | `rangeList`: a list of language ranges, separated by ';', ':', ',', or space characters. Each element must either be '*', or a RFC 3066 language range canonicalized as by `languageFromString`
-> m Bool | Returns: `True` if a match was found.

Checks if a language tag matches one of the elements in a list of language ranges. A language tag is considered to match a range in the list if the range is '*', the range is exactly the tag, or the range is a prefix of the tag, and the character after it in the tag is '-'.

## toString

languageToString Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Language | `language`: a language tag.
-> m Text | Returns: a string representing the language tag. This is owned by Pango and should not be freed.

Gets the RFC-3066 format string representing the given language tag.